Disclaimer

Insyde Corporation provides this document and the programs "as is" without warranty of any kind, either expressed or implied, including, but not limited to, the implied warranties of merchantability or fitness for a particular purpose.

This document could contain technical inaccuracies or typographical errors. Changes are periodically made to the information herein; these changes will be incorporated in future revisions of this document. Insyde Corporation is under no obligation to notify any person of the changes.

Copyright (c) 2006, Insyde Corporation

All rights reserved; no part of this publication may be reproduced, transcribed, stored in a retrieval system, translated into any language or computer language, transmitted in any form, or by any means, electronic, mechanical, magnetic, optical, chemical, manual, or otherwise, without the prior written permission of Insyde Corporation.

Insyde is a registered trademark of Insyde Corporation. AT and PS/2 are registered trademarks of IBM Corporation.


1

The EzH2O program is designed to provide interfacing functions that allow users to replace the content of BIOS or to modify the initial value in the BIOS. To perform these interface options, users must first load an FD file.


2

2. Using the Program

Figure 2-1 shows the EzH2O menu bar that is located on the top of the screen. On the initial screen, you can use the File and Help functions.

Figure 2-1. The menu bar


2

2.1 File

To use the File function, select File from the menu bar. A drop-down menu appears as shown in Figure 2-2.

Figure 2-2. The File menu

Load File – Read any FD file. Upon loading the file, you can then select other options in this menu like Close, Save or Save As; or use such menu-bar functions as Components, Binary-Rom, Other, ROM-Translation, etc.

Close – Close the file in use.

FD Information – Show the FD size, PEI size, PEI Freespace, DXE size, DXE freespace, Microcode size, Microcode freespace, etc., as shown in Figure 2-3.

Rules for calculating the Microcode size and Microcode freespace:

¾ If there is a flashmap.fdf file existing in the directory level above the FD file, calculate them based on the content of this file; otherwise, specify “Underknow.”

¾ Upon selection of the Micro Code option through the Other function, calculate them based on the result.

Figure 2-3. The FD information

Log – Create the EzH2O.ini to record action that you use the utility with EzH2O.

Save – Store the file back to the FD file.

Save As – Store the current file as a new file.

Exit – Exit the current program.


2

2.2 Components

To use the Components function, select Components from the menu bar upon loading the file. A drop-down menu appears for you to select the option.

Logo Image

Selecting Logo Image pops up a window as shown in Figure 2-4. Through this Logo Image window, you can change the logo in your FD file; the PCX, JPG and BMP formats are supported.

Figure 2-4. The Logo Image window

Logo Image To Load – Specify the new graphic file.

Image Information – Upon reading the FD file, all the GUIDs of the graphic files in it are converted to the image information, e.g., format(pixel * pixel) .

View – Use this button to preview the picture selected.

If the format of the picture isn’t consistent with that of the FD image, a message appears, asking if you want to convert the FD image format into that of the picture. Give your choice as needed. Refer to Figure 2-5.

Figure 2-5. The Convert message

Module Replace

Selecting the Module Replace option pops up a window as shown in Figure 2-6. Through this Module Replace window, you can change the module; the ORG, FFS and EFI formats are supported.

Figure 2-6. The Module Replace window

Module To Load – Specify the new module.

Change Rom GUID – Select the GUID for the existing module to be replaced.

To use the Components function, select Components from the menu bar upon loading the file. A drop-down menu appears for you to select the option.

Insert New Module

Selecting the Insert New Rom option on the Components menu pops up a window as shown in Figure 2-7. Through this Insert New Module window, you can Insert the module; the ORG, FFS, PEI and DXE formats are supported.

Figure 2-7. The Insert Mew Module window

New Module Path – Specify the new module.

FV – Select the FV to insert.

Delete Existing Module

Selecting the Delete Existing Module option pops up a window as shown in Figure 2-8. Through this Delete Existing Module window, you can delete the module.

Figure 2-8. The Delete Existing Module window

GUID – Specify the GUID for the module to be deleted.


2

2.3 Binary-Rom

To use the Binary-Rom function, select Binary-Rom from the menu bar upon loading the file. A drop-down menu appears for you to select the option.

On Board VGA \ External VGA \ PXE

Selecting On Board VGA \External VGA \ PXE pops up a window as shown in following figure. Through this Option window, you can change the Option ROM in your FD file if there is any.

Figure 2-11. The Option Rom window


2

2.4 Other

To use the Other function, select Other from the menu bar upon loading the file. A drop-down menu appears for you to select the option.

Setup Menu

Selecting the Setup Menu option displays a window as shown in Figure 2-14. Through this window, you can read the BIOS setup information and modify the initial value of basic option.

Figure 2-14. The Setup Menu window

OEMDS

Selecting the OEMDS option displays a window as shown in following figure. Through this window, you can change the OEMDS structure information.

What is OEMDS ?

  1. BIOS/Application requirement

OEM/ODM need to modify variable's default setting. However, variables are not easy for modification without source code. BIOS provide a data structure, it stores all items they need.

  2. BIOS Design

This structure is binary in BIOS ROM. It can store at any offset in file. The following table is a example.

0ffset | Size(Bytes) | Type | Define
0x00 | 0x07 | String | “$OEMDS$” header of Data
0x07 | 0x01 | Byte | OEM BIOS ROM table Version
0x08 | 0x02 | WORD | OEM BIOS ROM Table Length
0x0A | 0x01 | Byte | Bit 2: If set then use default position to display logo, else use 0x10~0x1A value define logo & prompt string position. Bit 1: If set then keyboard type is 8’, else 10’ Bit 0: If set then panel type is 800*480 else 1024*600.
0x0B | 0x01 | Byte | Reserved
0x0C | 0x04 | DWORD | The background color
0x10 | 0x02 | WORD(pixel) | Intel OSB logo left of the screen(Intel.x)
0x12 | 0x02 | WORD(pixel) | Intel OSB logo top of the screen(Intel.y)
0x14 | 0x02 | WORD(pixel) | Insyde OSB logo left of the screen(Insyde.x)
0x16 | 0x02 | WORD(pixel) | Insyde OSB logo top of the screen(Insyde.y)
0x18 | 0x02 | WORD(pixel) | The F2 & F12 prompt string left of the screen(x)
0x1A | 0x02 | WORD(pixel) | The F2 & F12 prompt string top of the screen(y)
0x0C | 0x04 | DWORD | Reserved
0x20 | 0x20 | String | OEM BIOS Version string
0x40 | 0x20 | String | OEM Vendor name string for DMI.
0x60 | 0x20 | String | OEM model name string
0x80 | 0x08 | String | OEM update bios date: (m/d/yyyy)
0x90 | 0x20 | String | OEM Board Serial Number
0xB0 | 0x10 | String | Battery 1 Model name
0xC0 | 0x10 | String | Battery 1 Serial number.
0xD0 | 0x10 | String | Battery 1 Info.
0xE0 | 0x10 | String | Battery 2 Model name
0xF0 | 0x10 | String | Battery 2 Serial number.
0x100 | 0x10 | String | Battery 2 Info.
0x110 | 0x10 | String | ACPI OEM ID
0x120 | 0x10 | String | ACPI OEM Table ID

  3. Application Design

In EzH2O, OEMDS.ini stores these settings.

[Platform] User can select all configurations in dialog

Items=2 How many configurations?

Platform0=Wanlida Name of configuration 1

Platform1=Wanlida Copy Name of configuration 2

[Wanlida]

Items=25 How many items?

Tag=$OEMDS$ EzH2O search this tag in ROM file.

DataSize=1024 Total length of data structure

Offset0=7 Offset of data structure

Size0=1 Size of value or string

Type0=0 0 is byte, 1 is word, 2 is double word, 3 is string, 4 is fixed length value.

Name0=This name will display in list box

Offset1=8

Size1=2

Type1=1

Name1=OEM BIOS ROM Table Length

Generate Logo FFS

Selecting the Generate Logo FFS option displays a window as shown figure that list as below. Through this Generate Logo FFS window, you can generate the logo(picture file) to become the FFS file.


2

2.6 Help

To use the Help function, select Help from the menu bar. A drop-down menu appears for you to select the option. The pop-up window may provide information on the operation or functionsmay also give information on the program version and copyright, as shown in Figure 2-16..

Figure 2-16. The About EzH2O window


3

3 Exercising the Example

3.1 Modify a Logo

3.2 Modify EC

3.3 Modify a Module

3.4 Modify the Microcode

3.5 Modify Default Setting of the Setupility

3.6 Modify the DMI Structure

3.7 Insert a New Module

3.8 Delete an Existing Module


3

To modify a logo, follow these steps:

1. Open the FD file to be modified:

- Select the Load File option via the File function (Figure 2-17).

- Specify the FD file (Figure 2-18).

- Show the FD information (Figure 2-19).

- Finish loading the FD file.

Figure 2-17. Selecting the Load File option

Figure 2-18. Specifying the FD file

Figure 2-19. Showing the FD information

2. Display the Logo Image window:

? Select the Logo option via the Components function (Figure 2-20)

? Pop up the Logo Image window (Figure 2-21)

Figure 2-20. Selecting the Logo option

Figure 2-21. Popping up the Logo Image window

3. Specify the format of image file (Figure 2-22). You can also press the View button to preview the image file, as shown in Figure 2-23.

Figure 2-22. Specifying the image format

Figure 2-23. Viewing the image file

4. Specify the image file to be modified (Figure 2-24).

Figure 2-24. Specifying the image file

5. Specify the logo image to be loaded (Figure 2-25).

Figure 2-25. Specifying the logo image

6. Press the Patch button to replace the image file specified. If both files are not consistent in format or size, a window pops up asking you to convert. Press Yes to convert. Refer to Figure 2-26.

Figure 2-26. Specifying the logo image and conversion

7. Upon completion of modification, the lower-left turn corner of the main screen displays the message “FD file modify finished.”


3

3.2 Modify EC

To modify EC, follow these steps:

1. Read the FD file (refer to Figures 2-17 thru 2-19). If EC exists in the file, the Binary-Rom function on the menu bar is enabled, allowing you to select the EC option.

2. When you select the EC option, the Ec Rom window appears (Figure 2-27).

Figure 2-27. The Ec Rom window

3. Read the binary file of Ec Rom (Figure 2-28).

Figure 2-28. Specifying the binary file

Push the Patch button to begin modifying EC. Once the modification has been successfully completed, the Ec Rom window is closed, and the lower-left turn corner of the main screen displays the message “FD file modify finished.”


3

3.3 Modify a Module

To modify a module, follow these steps:

1. Read the FD file (refer to Figures 2-17 thru 2-19).

2. Select the Module option via the Components function. The Module Replace window pops up.

3. When the Module Replace window appears, specify the module to be replaced, and also specify the corresponding GUID. Refer to Figure 2-29.

Figure 2-29. The Module Replace window

Push the Patch button to begin modifying the module. Once the modification has been successfully completed, the Module Replace window is closed, and the lower-left turn corner of the main screen displays the message “FD file modify finished.”


3

3.4 Modify the Microcode

To modify the microcode, follow these steps:

1. Read the FD file (refer to Figures 2-17 thru 2-19).

2. Select the Micro Code option via the Other function. The Micro Code window pops up.

3. When the Micro Code window appears, specify the microcode file (either in text or binary) to be replaced, and also specify the corresponding Flashmap.fdf file. Refer to Figure 2-30.

Figure 2-30. The Micro Code window

Push the Patch button to begin modifying the microcode. Once the modification has been successfully completed, the Micro Code window is closed, and the lower-left turn corner of the main screen displays the message “FD file modify finished.”


3

3.7 Insert a New Module

To insert a module, follow these steps:

1. Read the FD file (refer to Figures 2-17 thru 2-19).

2. Select the Insert New Rom option on the Components menu to pop up the Insert New Module window. Specify the new module path and the FV (Figures 2-34).

Figure 2-34. Specifying the new module

Push the Path button to begin inserting the module. Once successfully completed, the Insert New Module window is closed, and the lower-left turn corner of the main screen displays the message “FD file modify finished.”


3

3.8 Delete an Existing Module

To delete a module, follow these steps:

1. Read the FD file (refer to Figures 2-17 thru 2-19).

2. Select the Delete Existing Module option on the Components menu to pop up the Delete Existing Module window. Specify the GUID of the module to be deleted (Figures 2-35).

Figure 2-35. Specifying the existing module

Push the Path button to begin deleting the module. Once successfully completed, the Delete Existing Module window is closed, and the lower-left turn corner of the main screen displays the message “FD file modify finished.”

3. If user want add the name of module after GUID (Figures 2-36) , then user can modify the Module_GUID_2_Name.ini to add the GUID and name.(Figures 2-37). The Module_GUID_2_Name.ini have already added some of sets. If the names and GUID are not match , then user can modify them.

Figure 2-36. Name of module after GUID

Figure 2-37. Module_GUID_2_name.ini


3

3.9 Gerenate Logo FFS

To modify default settings of the Setup Utility, follow these steps:

1. Read the FD file (refer to Figures 2-17 thru 2-19).

2. Select the Setup Utility option via the Other function. The Setup Utility window appears, showing the initial settings of BIOS (Figure 2-31).

3. Use the mouse to modify the setting as required.(Figure 2-31-2)

4. To exit, press the Patch button or press the Cancel option, either saving or without saving the file.(Figure 2-31-2)

Figure 2-31. The Setup Utility window

Figure 2-31-2. The Setup Utility modify window